#include <stdio.h>
#include <stdlib.h>

static	unsigned long	hex2str(unsigned char *c, int len)
{
	int	i;
	unsigned long	val;

	val = 0;
	for (i = 0; i < len; i++) {
		if (*c == NULL) break;
		val <<= 4;
		if (*c >= '0' && *c <= '9') val |= *c - '0';
		else if (*c >= 'A' && *c <= 'Z') val |= *c - 'A' + 10;
		else if (*c >= 'a' && *c <= 'z') val |= *c - 'a' + 10;
		c++;
	}
	
	return val;
}

int	main(int argc, char *argv[])
{
	int	result;
	unsigned long	p, l;
	FILE	*f;

	if (argc < 4) {
		printf("usage:	memsave [filename] [address(hex)] [length(hex)] \n");
		printf("	address c800:0000 -> c8000000\n");
		result = EXIT_FAILURE;
		goto fin0;
	}

	f = fopen(argv[1], "wb");
	p = hex2str(argv[2], 8);
	l = hex2str(argv[3], 8);

	printf("%04lx:%04lx, %ld byte\n", (p >> 16) & 0xffff, p & 0xffff, l);

	if (f == NULL) {
		printf("file open error!\n");
		result = EXIT_FAILURE;
		goto fin0;
	}

	if (fwrite((unsigned char far *)p, 1, l, f) < l) {
		printf("file write error!\n");
		result = EXIT_FAILURE;
	} else {
		result = EXIT_SUCCESS;
	}


	fclose(f);
 fin0:	
	return result;
}
